
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Ir_management_membersDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const ir_management_members = await db.ir_management_members.create(
            {
                id: data.id || undefined,
        
        full_name: data.full_name
        ||
        null
            ,
            
        title: data.title
        ||
        null
            ,
            
        bio: data.bio
        ||
        null
            ,
            
        display_order: data.display_order
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await ir_management_members.setIr_company( data.ir_company || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.ir_management_members.getTableName(),
                belongsToColumn: 'profile_images',
                belongsToId: ir_management_members.id,
            },
            data.profile_images,
            options,
        );
        

        return ir_management_members;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const ir_management_membersData = data.map((item, index) => ({
                id: item.id || undefined,
                
                full_name: item.full_name
            ||
            null
            ,
            
                title: item.title
            ||
            null
            ,
            
                bio: item.bio
            ||
            null
            ,
            
                display_order: item.display_order
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const ir_management_members = await db.ir_management_members.bulkCreate(ir_management_membersData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < ir_management_members.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.ir_management_members.getTableName(),
                    belongsToColumn: 'profile_images',
                    belongsToId: ir_management_members[i].id,
                },
                data[i].profile_images,
                options,
            );
        }
        

        return ir_management_members;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const ir_management_members = await db.ir_management_members.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.full_name !== undefined) updatePayload.full_name = data.full_name;
        
        
        if (data.title !== undefined) updatePayload.title = data.title;
        
        
        if (data.bio !== undefined) updatePayload.bio = data.bio;
        
        
        if (data.display_order !== undefined) updatePayload.display_order = data.display_order;
        
        
        updatePayload.updatedById = currentUser.id;

        await ir_management_members.update(updatePayload, {transaction});

        
        
        if (data.ir_company !== undefined) {
            await ir_management_members.setIr_company(
              
              data.ir_company,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.ir_management_members.getTableName(),
                belongsToColumn: 'profile_images',
                belongsToId: ir_management_members.id,
            },
            data.profile_images,
            options,
        );
        

        return ir_management_members;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const ir_management_members = await db.ir_management_members.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of ir_management_members) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of ir_management_members) {
                await record.destroy({transaction});
            }
        });


        return ir_management_members;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const ir_management_members = await db.ir_management_members.findByPk(id, options);

        await ir_management_members.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await ir_management_members.destroy({
            transaction
        });

        return ir_management_members;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const ir_management_members = await db.ir_management_members.findOne(
            { where },
            { transaction },
        );

        if (!ir_management_members) {
            return ir_management_members;
        }

        const output = ir_management_members.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.ir_company = await ir_management_members.getIr_company({
            transaction
        });
        
        
        output.profile_images = await ir_management_members.getProfile_images({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.ir_companies,
        as: 'ir_company',
        
        where: filter.ir_company ? {
          [Op.or]: [
            { id: { [Op.in]: filter.ir_company.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.ir_company.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



      {
        model: db.file,
        as: 'profile_images',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.full_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'ir_management_members',
                        'full_name',
                        filter.full_name,
                    ),
                };
            }
            
            if (filter.title) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'ir_management_members',
                        'title',
                        filter.title,
                    ),
                };
            }
            
            if (filter.bio) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'ir_management_members',
                        'bio',
                        filter.bio,
                    ),
                };
            }
            

            
            

            
            if (filter.display_orderRange) {
                const [start, end] = filter.display_orderRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    display_order: {
                    ...where.display_order,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    display_order: {
                    ...where.display_order,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            


      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.ir_management_members.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'ir_management_members',
                        'full_name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.ir_management_members.findAll({
            attributes: [ 'id', 'full_name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['full_name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.full_name,
        }));
    }

    
};

